#include "AnimFrame.h"

#include "SDL.h"
#include "SDL_image.h"

#include <vector>
#include <iostream>
#include <string>
using namespace std;

AnimFrame :: AnimFrame (string n)
{
  pic = IMG_Load(n.c_str());
}

void AnimFrame :: setOffsetAndTime (Sint32 x, Sint32 y, Uint32 t)
{
  xOffset = x;
  yOffset = y;
  timeToHoldFrame = t;
}

int AnimFrame :: render (SDL_Surface * dest, SDL_Rect & center)
{
  //render this frame on dest, centered on center. xOffset and yOffset offset the positioning.

  SDL_Rect temp;

  temp.x = center.x + xOffset;
  temp.y = center.y + yOffset;
  SDL_BlitSurface(pic, NULL, dest, &temp);

  return 0;
}

bool AnimFrame :: isValid ()
{
  //returns false if pic is NULL.

  if (pic == NULL)
    return false;

  return true;
}

Uint16 AnimFrame :: getTime ()
{ return timeToHoldFrame; }

AnimFrame :: ~AnimFrame ()
{
  SDL_FreeSurface (pic);
}
