#ifndef LINEPATTERN_H
#define LINEPATTERN_H

#include "SDL.h"
#include "SDL_gfxPrimitives.h"
#include <vector>
using namespace std;

class LinePattern {
 public:
  LinePattern ();
  ~LinePattern ();
  void init (SDL_Rect dim, SDL_Color & rulz);
  Uint32 chooseColor (SDL_Rect pt, SDL_Surface * dest, Uint8 & r, Uint8 & g, Uint8 & b, Uint8 & a);
  void render (SDL_Surface * dest, SDL_Rect dim);
  int getLastPoint (SDL_Rect & ptA);
  int getContactPoint (SDL_Rect & ptA);
  int get2ndContactPoint (SDL_Rect & ptA);
  void getNewLine (SDL_Rect, bool);
 protected:
  SDL_Rect generateNextPoint (SDL_Rect);
  bool boundaryNextPoint (SDL_Rect &, SDL_Rect, Sint32 &);
  void addWeight (Uint8 &, Uint8 &, Uint8);

  vector <SDL_Rect> points;
  //add rules for drawing line here?

  Uint8 startVector;
  Uint8 distBetweenPoints;
  Uint8 angleBetweenPoints;

  Uint16 currentAngle;
  Uint8 mainAngleIndex;
  Sint32 totalRotation;
  bool firstPoint;

  Uint16 ang1;
  Uint16 ang2;

  double sin1;
  double cos1;
  double sin2;
  double cos2;

  Uint8 totalNumDots;

  vector < vector <Uint8> > angleChangeDistribution;
};

void RGBtoHSV(Uint8, Uint8, Uint8, Uint16 &, Uint16 &, Uint16 &);
void HSVtoRGB(Uint16, Uint16, Uint16, Uint8 &, Uint8 &, Uint8 &);

void RGBtoHSVhelper( float r, float g, float b, float *h, float *s, float *v );
void HSVtoRGBhelper( float *r, float *g, float *b, float h, float s, float v );
float MIN (float a, float b, float c);
float MAX (float a, float b, float c);
#endif
