#include "MediaPlayer.h"

#include "SDL.h"
#include "SDL_image.h"

#include <vector>
#include <iostream>
#include <string>
using namespace std;

#include "MediaResource.h"

MediaPlayer :: MediaPlayer (MediaResource * mr)
{
  medRes = mr;
  animToPlay = 0;
  animIndexToPlay = 0;
  channelToPlay = 0;
  startTime = SDL_GetTicks ();
}

int MediaPlayer :: render (SDL_Surface * dest, SDL_Rect & center)
{
  //calls medRes for the next picture and pastes it.
  //also increments the frame if it needs to.

  medRes -> drawPic (dest, center, animToPlay, animIndexToPlay);

  //check if it's time to change frames.

  if (medRes -> changePic (SDL_GetTicks () - startTime, animToPlay, animIndexToPlay, loopCounter) != 0)
    startTime = SDL_GetTicks ();
  return 0;
}

int MediaPlayer :: changeAnim (Uint8 index)
{
  if (index < 4)
    {
    animToPlay = Uint32(index);
    animIndexToPlay = 0;
    startTime = SDL_GetTicks ();    
    loopCounter = medRes -> getLoops (index);
    }
  return 0;
}

MediaPlayer :: ~MediaPlayer ()
{
}
